/*
 * lmsensors, configurable PMDA
 *
 * Written by Troy Dawson on January 2, 2001
 *
 */

#ident "$Id: lmsensors.c,v 0.5 2001/01/04 10:00:00 dawson Exp $"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include "fermiburn.h"

static char buf[4096];

seti get_seti()
{
	int i;
	int n;
	int nbufindex;
	float f;
	char *bufindex[64];
	char *temp;
	char *temptoken;
	seti newseti={11.111,22.222};
	
	n = get_file("seti/stage1/", "state.sah");
	buf[sizeof(buf)-1] = '\0';
	n = 1000;
	nbufindex = 0;
	bufindex[nbufindex++] = &buf[0];
	for (i=0; i < n; i++) {
		if (buf[i] == '\n') {
			buf[i] = '\0';
			bufindex[nbufindex++] = buf + i + 1;
		}
	}

	for ( i=0; i < nbufindex ; i++ ) {
		temp="";
		if (strncmp("prog", bufindex[i], 4) == 0 ) {
			temp = strtok(bufindex[i]," ");
			temptoken = strtok(temp,"=");
			temptoken = strtok(NULL," ");
			f = atof(temptoken);
			newseti.stage1=100*f;	
			i = nbufindex;
		}
	}	

	n = get_file("seti/stage2/", "state.sah");	
	buf[sizeof(buf)-1] = '\0';
	n = 1000;
	nbufindex = 0;
	bufindex[nbufindex++] = &buf[0];
	for (i=0; i < n; i++) {
		if (buf[i] == '\n') {
			buf[i] = '\0';
			bufindex[nbufindex++] = buf + i + 1;
		}
	}

	for ( i=0; i < nbufindex ; i++ ) {
		temp="";
		if (strncmp("prog", bufindex[i], 4) == 0 ) {
			temp = strtok(bufindex[i]," ");
			temptoken = strtok(temp,"=");
			temptoken = strtok(NULL," ");
			f = atof(temptoken);
			newseti.stage2=100*f;	
			i = nbufindex;
		}
	}	

	return newseti;
}

bonnie get_bonnie()
{
	int i;
	int n;
	int nbufindex;
	char *bufindex[64];
	char *temp;
	char *temptoken;
	bonnie newbonnie={1111,2222,3333,4444};
	
	n = get_file("root/test/bonnie_current.", "stage1");
	
	buf[sizeof(buf)-1] = '\0';

	nbufindex = 0;
	bufindex[nbufindex++] = &buf[0];
	for (i=0; i < n; i++) {
		if (buf[i] == '\n') {
			buf[i] = '\0';
			bufindex[nbufindex++] = buf + i + 1;
		}
	}
	
	for ( i=0; i < nbufindex ; i++ ) {
		temp="";
		if (strncmp("wKb/sec", bufindex[i], 7) == 0 ) {
			temp = strtok(bufindex[i+1]," ");
			temptoken = strtok(temp,"\t");
			newbonnie.stage1write = atoi(temptoken);
			temptoken = strtok(NULL," ");
			newbonnie.stage1read = atoi(temptoken);
		}
	}	

	n = get_file("root/test/bonnie_current.", "stage2");
	
	buf[sizeof(buf)-1] = '\0';

	nbufindex = 0;
	bufindex[nbufindex++] = &buf[0];
	for (i=0; i < n; i++) {
		if (buf[i] == '\n') {
			buf[i] = '\0';
			bufindex[nbufindex++] = buf + i + 1;
		}
	}
	
	for ( i=0; i < nbufindex ; i++ ) {
		temp="";
		if (strncmp("wKb/sec", bufindex[i], 7) == 0 ) {
			temp = strtok(bufindex[i+1]," ");
			temptoken = strtok(temp,"\t");
			newbonnie.stage2write = atoi(temptoken);
			temptoken = strtok(NULL," ");
			newbonnie.stage2read = atoi(temptoken);
		}
	}	

	return newbonnie;
}


/*
 * Get the contents of a file and return them
 */
int get_file(char *middle, char *end){

	int fd;
	int n;
	int i;
	char s[1024]="/";
	
/*
 * create the new string, the end result being the actual file name
 */
	strcat(s,middle);
	strcat(s,end);

/*
 * read in the file into the buffer buf
 */
	if ((fd = open(s, O_RDONLY)) < 0) {
		return -1;
	}
	n = read(fd, buf, sizeof(buf));
	close(fd);
	return n;
}

/*
 * Initialise the agent (both daemon and DSO).
 */
void 
lmsensors_init(void)
{
	seti seti1;
	bonnie bonnie1;
	printf (" We are getting seti\n");
	seti1=get_seti();
	printf (" We are getting bonnie\n");
	bonnie1=get_bonnie();
	printf (" RESULTS\n");
	fprintf(stdout, "Seti1: %f Seti1: %f \n",seti1.stage1,seti1.stage2);
	fprintf(stdout, "Bonnie1write:%d Bonnie1read:%d\n",bonnie1.stage1write,bonnie1.stage1read);
	fprintf(stdout, "Bonnie2write:%d Bonnie2read:%d\n",bonnie1.stage2write,bonnie1.stage2read);
}

/*
 * Set up the agent if running as a daemon.
 */
int
main(int argc, char **argv)
{
    lmsensors_init();

    exit(0);
    /*NOTREACHED*/
}
